### A Pluto.jl notebook ###
# v0.19.11

using Markdown
using InteractiveUtils

# This Pluto notebook uses @bind for interactivity. When running this notebook outside of Pluto, the following 'mock version' of @bind gives bound variables a default value (instead of an error).
macro bind(def, element)
    quote
        local iv = try Base.loaded_modules[Base.PkgId(Base.UUID("6e696c72-6542-2067-7265-42206c756150"), "AbstractPlutoDingetjes")].Bonds.initial_value catch; b -> missing; end
        local el = $(esc(element))
        global $(esc(def)) = Core.applicable(Base.get, el) ? Base.get(el) : iv(el)
        el
    end
end

# ╔═╡ b72215bb-8e3a-46e2-8817-271befe1178c
begin
	using PlotlyBase
	using HypertextLiteral
	using PlutoUI
	using LinearAlgebra
	using NLsolve
end

# ╔═╡ 0b869e70-3717-11ec-202c-6b94dac7daf3
md"""
# Teste Final: Macroeconomia (L0236)

#### Duração: 1 hora e 30 minutos.

## Instituto Universitário de Lisboa (ISCTE--IUL)

**09 Junho 2022**
"""

# ╔═╡ b326715f-c37f-44d2-92f9-6264368a18b2
md"""
#### Nome: Inserir nome completo , Nº: 000001
"""

# ╔═╡ 694d78c7-4762-4d40-8f9a-6c3d16916d4e
begin
	function Base.show(io::IO, mimetype::MIME"text/html", plt::PlotlyBase.Plot)
       # Remove responsive flag on the plot as we handle responsibity via ResizeObeserver and leaving it on makes the div flickr during updates
	hasproperty(plt,:config) && plt.config.responsive && (plt.config.responsive = false)   
	show(io,mimetype, @htl("""
			<div>
			<script id=asdf>
			const {plotly} = await import("https://cdn.plot.ly/plotly-2.2.0.min.js")
			const PLOT = this ?? document.createElement("div");
		

		
			Plotly.react(PLOT, $(HypertextLiteral.JavaScript(PlotlyBase.json(plt))));


		
			const pluto_output = currentScript.parentElement.closest('pluto-output')

			const resizeObserver = new ResizeObserver(entries => {
				Plotly.Plots.resize(PLOT)
			})

			resizeObserver.observe(pluto_output)

			invalidation.then(() => {
				resizeObserver.disconnect()
			})
		
			return PLOT
			</script>
			</div>
	"""))
	end
end

# ╔═╡ 60bab761-8537-46e3-9940-953cd47da4be
md"""
#####  RESPONDA APENAS A 4 GRUPOS, de forma sucinta e objectiva
"""

# ╔═╡ 4109af60-6178-4148-8efe-890245077188
md"""
## Exercício 1 (5 pontos)
"""

# ╔═╡ 25743265-a4d8-45c0-8c17-e75a2858441a
md"""
**a)** Tendo em conta a figura seguinte, considera que a mesma pode representar o comportamento descrito pela Curva de Phillips? Justifique de forma sucinta.
"""

# ╔═╡ 12c9405e-d2c2-4894-b04a-a534b15fe669
md"""
	!!! tip "Resposta (a)"

	    Aqui

	"""

# ╔═╡ e56d9748-1b72-48cf-ab1e-da84807da7c4
Resource("http://ebs.de.iscte.pt/aa_final_test_PC.png",:width=>700)

# ╔═╡ 86f778d3-cda5-4933-ad27-d4ae04978c1e
md"""
**b)** Em macroeconomia, para que serve a Lei de Okun?
"""

# ╔═╡ 4b393146-306e-4c85-a5a3-8cdbb511331c
md"""
	!!! tip "Resposta (b)"

	    Aqui

	"""

# ╔═╡ 8c9b8a47-b01e-49e7-8cc0-d6bd5ff9b723
md"""
**c)** Qual é a diferença fundamental que existe entre a regra de política monetária seguida pelo livro de texto e a regra de Taylor?
"""

# ╔═╡ 4e343e37-0beb-45ed-a879-adab6de87349
md"""
	!!! tip "Resposta (c)"

	    Aqui

	"""

# ╔═╡ 0015b626-1347-45f5-aef7-2b9b6675038c
md"""
**d)** Considere a seguinte Curva AS:

$$\pi =\pi^{e}+\gamma\left(Y-Y^{P}\right)+\rho$$

onde $\pi^e = 2\%$,  $\rho = 0\%$, $Y^{P} = 12$, e $\gamma = 3$. Por que razão se diz que a inflação é estável quando $Y=Y^{P}$?
"""

# ╔═╡ 9620f225-31b6-49f7-ba9c-efa940092463
md"""
	!!! tip "Resposta (d)"

	    Aqui

	"""

# ╔═╡ ecfc8987-e75b-4a8a-b4c6-71fcf45a8eff
md"""
**e)** Suponha que a regra de política monetária do banco central é dada pela seguinte expressão:

$$r = \overline{r} + 0.6 (\pi - \pi^T)$$

em que $\pi^T$ é o valor-objectivo que o banco central tem para a inflação ("inflation target"). Com esta regra, diga como procederia para calcular o nível da inflação no ZLB (não requer contas)?
"""

# ╔═╡ 97c76502-6281-4870-9b39-42f485c1a447
md"""
	!!! tip "Resposta (e)"

	    Aqui

	"""

# ╔═╡ c7e2c3fc-bf1c-4b1b-882a-b9e36d66a32b
# Não altere esta célula. Cotações por pergunta
Ia = 0.0 * 1 ; Ib = 0.0 * 1 ; Ic = 0.0 * 1 ; Id = 0.0 * 1 ;	Ie = 0.0 * 1 ; I = Ia + Ib + Ic + Id +Ie

# ╔═╡ 9b0f3199-ff28-4820-bcad-e59bc65ce8a6
md"""
## Exercício 2 (5 pontos)
"""

# ╔═╡ 541d8125-e5d0-46ec-a26d-aa1a130c38b2
md"""
Assumindo que a Curva de Phillips e a Lei de Okun são dadas por, respectivamente:

$$\pi=\pi^{e}-2.5(U-U_n)+\rho$$
$$U - U_n = -0.5 (Y - Y^P)$$

sabe-se também que $Y^P=10$ triliões de dólares e $\rho = 0\%$.

"""

# ╔═╡ f6f3809e-76a7-4db4-8fb8-59c9ab5a4ffd
md"""
**a)** Qual é o valor do declive da AS nesta economia?
"""

# ╔═╡ b8871ae8-2abc-4d26-b8e6-e610d40d5a23
md"""
	!!! tip "Resposta (a)"

	    Aqui

	"""

# ╔═╡ f5494e4f-ca4a-4b5d-95b1-5acf21b82d78
md"""
**b)** Se o PIB aumentar em 1 trilão de triliões de dólares, quanto aumentará a taxa de inflação?
"""

# ╔═╡ 3da99da9-e09e-4ded-94a9-5b11f5c08313
md"""
	!!! tip "Resposta (b)"

	    Aqui

	"""

# ╔═╡ 73e9803b-7d8b-4281-8e0c-8f2294ba7612
md"""
**c)** Sabendo que a inflação esperada é de $3.0\%$, qual o nível do PIB que corresponderá ao equilíbrio macroeconómico?

"""

# ╔═╡ 3f211cef-c684-4e25-9144-19d68b0d8bd0
md"""
	!!! tip "Resposta (c)"

	    Aqui

	"""

# ╔═╡ cf06eb79-fc37-4784-b747-8a0965d5d436
md"""
**d)** Na figura abaixo ("The AS function") qual o factor que leva a economia a deslocar-se do ponto 1 para o ponto 2?
"""

# ╔═╡ ff0f7991-1b37-44a1-a701-d8c071b6ac59
md"""
	!!! tip "Resposta (d)"

	    Aqui

	"""

# ╔═╡ 4297e128-e56e-4624-a603-8f7343648b86
md"""
**e)** Na referida figura, qual o factor que leva a economia a deslocar-se do ponto 1 para o ponto 3?
"""

# ╔═╡ 308427f8-09ff-4370-8641-b3cd9a3668d1
md"""
	!!! tip "Resposta (e)"

	    Aqui

	"""

# ╔═╡ 3a173221-bce2-4bd2-8078-1b4695df3bbe
begin
	output = 4:0.01:16
	
	PC = 3.0 .+(2.5 .* 0.5).*(output .- 10.0)
	
	trace7_24 = scatter(;x =output, y = PC, 
					name = "AS", line_color = "Blue", mode = "lines", 
					line_width="2.0")
		
	trace7_25 = scatter(; x = [10.0, 10.0, 10.8], y = [3.0, 4.5 , 4.0], text = ["1", "2" , "3"], 
					textposition = "top center", name = "", mode="markers+text", marker_size= "12",
					marker_color="blue",	
					textfont = attr(family="sans serif", size=16, color="black"))
	
	layout7_25 = Layout(;
					title_text = "The AS function",
					title_x = 0.5,
        			yaxis_title = "Rate of Inflation",
					yaxis_zeroline= false,
					hovermode="x",
        			xaxis_range = [9.0, 11.5],
        			xaxis_title = "GDP (trillion dollars)",
					xaxis_zeroline= false,
        			yaxis_range=[1.8, 5.0], 
        			titlefont_size=18)

	
	p7_25=Plot([trace7_24, trace7_25], layout7_25)
end

# ╔═╡ cff3fc5b-326b-4efe-836b-229cd23f83cc
# Não altere esta célula. Cotações por pergunta.
IIa = 0.0 * 1; IIb = 0.0 * 1; IIc = 0.0 * 1; IId = 0.0 * 1;	IIe = 0.0 * 1;	II = IIa + IIb + IIc + IId + IIe

# ╔═╡ 9b622087-ad34-4f19-9929-cbdf0256eae0
md"""
## Exercício 3 (5 pontos)
"""

# ╔═╡ 7a8ac6a0-09cf-437e-9b8d-277182c0cdd0
md"""
Considere o modelo macroeconómico completo com as 4 equações fundamentais:

$$\begin{align*}
\text{AD}: \quad Y &=m \cdot \overline{A}-m \cdot \phi \cdot(\overline{r}+\lambda \pi) \\[2mm]           
\text{AS}: \quad  \pi &=\pi^{e}+\gamma\left(Y-Y^{P}\right)+\rho \\[2mm]  
\text{MP}: \quad r&=\overline{r}+\lambda \pi \\[2mm]  
\text{Fisher Eq.}: \quad i& =r +\pi
\end{align*}$$

onde: $$\qquad \overline{A}= 7.8 \ , \ m=2.0\ , \ \phi=0.2\ , \ \overline{r}=2.0 \ , \ \lambda=0.5 \ , \ \pi^{e}=3.0 \ , \ \gamma=2.8 \ , \ Y^{P}=14.2 \ ,  \ \rho=0$$

"""

# ╔═╡ 37e34e48-c2a7-4ffd-ac97-1a6ecb44ea92
begin	
	# AD	
	Ā3 = 7.8 ;	λ3 = 0.5 ;	m3 = 2.0 ;	ϕ3 = 0.2 ;	r̄3 = 2.0 ;	
	
	# AS	
	γ3  = 2.8 ;	Yᴾ3 = 14.2 ;	πᵉ3 = 3.0 ;	ρ3  = 0.0 ;
	
	# Intercepts (useful to simplify notation)	
	πd_max3 = (Ā3 / (λ3 * ϕ3)) - r̄3/λ3        # The AD curve y-axis' intercept
	πs_min3 = πᵉ3 - γ3 * Yᴾ3 + ρ3             # The AS curve y-axis' intercept
end;

# ╔═╡ 02d7d12a-9d2f-4ad4-8ad0-2fb15ea02cb7
md"""
**a)** Calcule o nível de equílibrio para o PIB, a taxa de inflação, a taxa de juro real, e a taxa de juro nominal, usando um método à sua escolha (recomendamos o uso de `NLsolve`).
"""

# ╔═╡ d3341903-3381-47bf-b6b0-6b909542a032


# ╔═╡ 700f5950-936d-46bd-9a9e-aa8ac4b9f653


# ╔═╡ a8f0040c-5029-451d-99d8-4cc90c45fa40
md"""
	!!! tip "Resposta (a)"

	    Aqui

	"""

# ╔═╡ 228f0209-c3ff-483a-bdd2-d7ef69e03b29
md"""
**b)** Suponha que o equilíbrio pode ser representado conforme figura "**A decrease in public spending**". Se o Governo **diminuir** a despesa pública em 0.15 triliões de dólares, descreva os passos que a economia irá dar até chegar ao novo equilíbrio macroeconómico _de longo prazo_, indicando os *valores* do PIB e da taxa de inflação em cada um dos passos (**_use a figura_**).
"""

# ╔═╡ 5eb07074-11f2-4798-a080-bcde73e51b38
md"""
	!!! tip "Resposta (b)"

	    Aqui

	"""

# ╔═╡ f9b8b4a6-31f4-4168-acda-92796adf3102
md"""
**c)** Usando a figura "**MP function**", quais serão os *valores* para a taxa de juro real e para a taxa de juro nominal, face ao ajustamento que resulta daquela redução na despesa pública?

"""

# ╔═╡ a5f978b7-4f8e-40b4-b52e-31e87d18c6a2
md"""
	!!! tip "Resposta (c)"

	    Aqui

	"""

# ╔═╡ ef51d01e-40c0-4b94-8308-4d3154c6099b
md"""
**d)** Se o banco central tiver um valor de 2% como objectivo para a taxa de inflação, e não abdicar do mesmo, será o novo equilíbrio que determinou na alínea (b) um equilíbrio estável? Como procederia o banco central para atingir o seu objetivo?
"""

# ╔═╡ 8fb613a7-45b7-46dc-be33-4ac74609d920
md"""
	!!! tip "Resposta (d)"

	    Aqui

	"""

# ╔═╡ f3d1f71c-5108-4394-a98d-dc670f1091ae
md"""
`ΔĀ3 = `$(@bind ΔĀ3 Slider(-1.0:0.05:1.0, default=0.0, show_value=true))
"""

# ╔═╡ 6db02201-bbe3-4ca8-a36b-7a5ac9e6385e
begin
	Y3 = 13.4:0.001:15.6
	
	πd3 = πd_max3 .- ((1 ./(m3 .* ϕ3 .* λ3)) .* Y3) 	# AD function
	πs3 = πs_min3 .+ γ3 .*Y3             				# AS function
	
	trace9_0 = scatter(; x = [14.2,14.2] , y = [-5,10] , mode = "line", line_width = "4", name = "Yp", 
					line_color = "Orange")
	
	trace9_1 = scatter(; x = Y3, y = πd3, mode="lines" , line_color = "Blue", line_width = "3",
			name  = "AD")
	
	trace9_2 = scatter(; x = Y3, y = πs3, mode="lines" , line_color = "Red", line_width = "3",
					name  = "AS")
	
	trace9_3 = scatter(; x = [14.2], y = [3.0], text =["1"], 
					textposition = "top center", name ="Eq1", mode="markers+text", marker_size= "12",
					marker_color="Blue", textcolor = "Black",
	 				textfont = attr(family="sans serif", size=18, color="black"))


	πd_max3_ΔĀ3 = ((Ā3 .+ ΔĀ3) ./ (λ3 .* ϕ3)) .- r̄3 ./ λ3 # New max value of the AD function
	
	πd3_ΔĀ3 = πd_max3_ΔĀ3 .- ((1 ./(m3 .* ϕ3 .* λ3)) .* Y3) # AD function
	
	
	trace9_4 = scatter(; x = Y3, y = πd3_ΔĀ3, mode="lines" , line_color = "Magenta", 
					 line_width = "3", name  = "AD2")
		
	#trace9_5 = scatter(; x = [14.21], y = [2.947], text =["2"], 
	#				textposition = "top center", name ="Eq2", mode="markers+text", 
	#				marker_size= "12", marker_color="Magenta",
	#				textfont = attr(family="sans serif", size=16, color="black"))
	
	
	layout9_5 = Layout(;
					title_text ="A decrease in public spending",
					title_x = 0.5,
					hovermode = "x",
                    xaxis=attr(title=" GDP trillion dollars (Y)", showgrid=true, zeroline=false),
                    xaxis_range = [13.8, 14.6],	
                    yaxis=attr(title="Rate of inflation (π)", zeroline = false),
					yaxis_range=[1.0 , 5.0])

   p9_4 = Plot([trace9_0, trace9_1, trace9_2, trace9_4, trace9_3], layout9_5)
	
	
end

# ╔═╡ f4efa92e-9a43-4bc3-8924-9ef7adeba5fd
begin
	r3 = 0.0:0.01:5.0
	
	πmp3 = - (r̄3 ./ λ3) .+  r3 ./ λ3 
	
	trace4_1 = scatter(; x = r3, y = πmp3, mode="lines" , line_color = "Brown", line_width = "3",
			name  = "MP")
	
	trace4_2 = scatter(; x = [3.5], y = [3.0], text =["1"], 
					textposition = "top center", name ="Eq1", mode="markers+text", 
					marker_size= "12", marker_color="Brown", 
					textfont = attr(family="sans serif", size=18, color="black"))
	
	layout4_1 = Layout(;
					title_text = "MP Function",
					title_x = 0.5,
					hovermode = "x",
                    xaxis=attr(title=" Real interest rate (r)", showgrid=true, zeroline=false),
                    xaxis_range = [2.0, 4.0],
					#xaxis_tickvals = [2, 2.5, 3, 3.5, 4, 4.5],
                    yaxis=attr(title="Rate of inflation (π)", zeroline = false),
					yaxis_range=[0.0 , 4.0])

   p4_1 = Plot([trace4_1, trace4_2], layout4_1)
end

# ╔═╡ 83da306c-64fa-4231-b396-b2006cd3ae05
# Não altere esta célula. Cotações por pergunta.
IIIa = 0.0 * 1; IIIb = 0.0 * 1.5; IIIc = 0.0 * 1.5; IIId = 0.0 * 1;	III = IIIa + IIIb + IIIc + IIId 

# ╔═╡ 36a0155e-86a5-461a-9b29-bf5b12e29e1b
md"""
## Exercício 4 (5 pontos)
"""

# ╔═╡ 4f2bd28d-abe2-43eb-9b7c-65e4ee574499
md"""
Levando em consideração **os mesmos dados do exercício anterior**, ou seja:

$$\overline{A}= 7.8 \ , \ m=2.0\ , \ \phi=0.2\ , \ \overline{r}=2.0 \ , \ \lambda=0.5 \ , \ \pi^{e}=3.0 \ , \ \gamma=2.8 \ , \ Y^{P}=142 \ ,  \ \rho=0$$

"""

# ╔═╡ 4c42fa41-327b-4440-994b-61eb23f1fe0e
md"""
**a)** Descreva como calcularia o nível da taxa de inflação que corresponde ao ZLB. Qual o valor desta taxa no ZLB (não faça contas, basta consultar a figura "**The AD/AS with a ZLB**").
"""

# ╔═╡ 46518335-709c-49e0-9f1c-8139f3b56ce8
md"""
	!!! tip "Resposta (a)"

	    Aqui

	"""

# ╔═╡ 8253e219-eb1c-4d25-b52b-17483cdfc37a
md"""
**b)** Estando a economia no ponto de equilíbrio 1, conforme figura "**The AD/AS with a ZLB**", suponha que existe um choque sobre a oferta, em que passamos a ter $\rho_2 = +3.0$. Utilizando o slider `ρ2` abaixo e a referida figura, diga qual será o novo ponto de equilíbrio da economia no curto prazo, resultante deste choque.
"""

# ╔═╡ 834f06dc-5e49-41e1-a226-a781c21fb50c
md"""
	!!! tip "Resposta (b)"

	    Aqui

	"""

# ╔═╡ d6a7f314-3c07-4634-80e7-863a223bbbf1
md"""
**c)** Qual será o novo ponto de equilíbrio de longo prazo? Porquê?
"""

# ╔═╡ b50b27f0-e713-42b8-98c1-d6594789e1e4
md"""
	!!! tip "Resposta (c)"

	    Aqui

	"""

# ╔═╡ 762be1ac-c471-461f-b2c5-48d9f8c49b9d
md"""
**d)** O ponto 2 na figura "**The AD/AS with a ZLB**" poderá ser um equilíbrio de longo prazo? Que tipo de choque teria de ocorrer para que o equilíbrio se verificasse no ponto 2?
"""

# ╔═╡ f0962852-02a2-4bf3-85b2-be0d4fb7bda4
md"""
	!!! tip "Resposta (d)"

	    Aqui

	"""

# ╔═╡ b721ee76-39ef-444b-aa90-5e199db90d42
md"""
`ρ2 = `$(@bind ρ2 Slider(-1.0:0.5:4.0, default=0.0, show_value=true))
"""

# ╔═╡ 1abf1b21-a268-45da-bcfc-b9cab7119ef4
# Não altere esta célula. Cotações por pergunta.
IVa = 0.0 * 1; IVb = 0.0 * 1; IVc = 0.0 * 1.5; IVd = 0.0 * 1.5; IV = IVa + IVb + IVc + IVd 

# ╔═╡ 52c76dc2-146c-4178-9aa3-d132a0551168
md"""
## Exercício 5 (5 pontos)
"""

# ╔═╡ 325f35d9-d2e7-49ac-a453-3c98fe0a0350
md"""
**a)** "Em Portugal, a dívida pública em percentagem do PIB ronda os 127% em 2021. A única forma que temos à nossa disposição para reduzir a dívida pública é ter um governo que produza excedentes orçamentais de montantes significativos". Comente esta frase de forma sucinta.

"""

# ╔═╡ 3a9518c4-6d37-48bc-bab0-9c70c8db94f9
md"""
	!!! tip "Resposta (a)"

	    Aqui

	"""

# ╔═╡ efbdb70a-cecc-40c3-84a7-e21792731a2f
md"""
**b)** No ano de 2020, o saldo orçamental da economia portuguesa (em percentagem do PIB) foi de $-5.7\%$, enquanto que os juros da dívida pública pagos foram de $2.9\%$ do PIB. Qual foi o valor do saldo primário neste ano?
"""

# ╔═╡ fda12fd7-377c-47e1-9344-7b0300e58997
md"""
	!!! tip "Resposta (b)"

	    Aqui

	"""

# ╔═╡ a6bfca48-9beb-4e75-bd23-d71c448b10a0
md"""
**c)** Nos EUA (bem como nos restantes países ocidentais), quais têm sido os principais factores que levaram ao agravamento das contas públicas, desde a década de 1960?

"""

# ╔═╡ eb782414-b0e8-4a9a-b68d-cf75662f6ca6
md"""
	!!! tip "Resposta (c)"

	    Aqui

	"""

# ╔═╡ 1bfeb360-0866-4a77-b7f4-34aff3541900
md"""
**d)** Usando os **sliders** abaixo, bem como a figura **"The evolution of Public Debt as % of GDP"**, e partindo de uma situação inicial de $d_{1}=1$ (ou seja: Dívida Pública / PIB = 1, ou 100%), caracterize um cenário em que a dívida pública se reduza para cerca de 65% do PIB.
"""

# ╔═╡ 4c790c8b-3192-4a75-acaa-c0224874a4d7
md"""
	!!! tip "Resposta (d)"

	    Aqui

	"""

# ╔═╡ 5ec7390c-2383-4033-9089-1c051b806912
md"""

`p = `$(@bind p Slider(-0.04:0.005:0.04, default=0.00, show_value=true))    .....# défice primário

`r = `$(@bind r Slider(0.0:0.0005:0.04, default=0.015, show_value=true)) .....# taxa de juro real

`g = `$(@bind g Slider(0.0:0.0005:0.05, default=0.02, show_value=true)) .....# taxa de crescimento do PIB real

`d_1 = `$(@bind d_1 Slider(0.0:0.25:2, default=1.0, show_value=true)) .....# dívida pública no período t-1

"""

# ╔═╡ bc7a7a3d-b43a-4db1-9f42-212226e10a29
# Não altere esta célula. Cotações por pergunta.
Va = 0.0 * 2; Vb = 0.0 * 1;	Vc = 0.0 * 1; Vd = 0.0 * 1; 	V = Va + Vb + Vc + Vd

# ╔═╡ f2956bed-9534-4c57-bfaa-fbef3c4af810
md"""
## Fim do teste
"""

# ╔═╡ edbd2b1c-1452-41a6-962c-3434bd420020
md"""
## Células auxiliares (não altere estas células)
"""

# ╔═╡ d9672a6f-97af-43d1-9a30-50495204fec8
 TableOfContents()

# ╔═╡ 0b4adabb-93f9-40d0-8571-b651dd68535c
NotaFinal = I + II + III + IV + V 

# ╔═╡ 1bf47443-0ee4-482a-b637-8081620c144b
begin
	π_ZL3= -r̄3 / (1+λ3)
	πd_min3 = - Ā3 / ϕ3
	Y_ZL3 = Ā3 * m3 - (m3 *  ϕ3 * r̄3) / (1+λ3)
	ρ4 = -3.15
end;

# ╔═╡ fc4af909-b4c5-4ebd-9e4b-fc93e3d31b8f
begin
	Y3_ZL = 13 : 0.001 : Y_ZL3

	πd3_normal = πd_max3  .- (1 ./(m3 .* ϕ3 .* λ3)) .* Y3_ZL
	
	πd3_ZL = πd_min3  .+ (1 ./(m3 .* ϕ3)) .* Y3_ZL

	πs4 = πs_min3 .+ γ3 .*Y3 .+ ρ2

	trace10_24 = scatter(; x = Y3_ZL , y = πd3_normal , mode = "line", name ="AD", line_color = "Blue")
	
	trace10_25 = scatter(; x = Y3_ZL , y = πd3_ZL , mode = "line", name ="ADzl", line_color = "BlueViolet")

	trace10_26 = scatter(; x = [13, 16] , y = [π_ZL3 , π_ZL3] , line_dash="dashdot", 
		line_width = "0.5", name = "ZLB", line_color = "black")

	trace10_27 = scatter(;x = Y3, y = πs4, mode="lines", line_color ="Red",line_width = "3", name="AS")

	trace10_28 = scatter(; x = [14.2], y = [3.0], text =["1"], 
					textposition = "top center", name ="Eq1", mode="markers+text", marker_size= "12",
					marker_color="Blue", textcolor = "Black",
	 				textfont = attr(family="sans serif", size=18, color="black"))

	trace10_30 = scatter(; x = [14.2], y = [-3.5], text =["2"], 
					textposition = "top center", name ="Eq3", mode="markers+text", marker_size= "12",
					marker_color="Gray", textcolor = "Black",
	 				textfont = attr(family="sans serif", size=18, color="black"))


		
	layout10_26 = Layout(
					title_text = "The AD/AS with a ZLB",
					title_x = 0.5,
					hovermode = "x",
					xaxis_title = "GDP trillion dollars (Y)",
					xaxis_range = [13.4 , 15.1],
					#yaxis_range=[-6 ,8],
					yaxis_title = "Rate of inflation (π)",
					yaxis_range=[-5.0 ,8.0], 
					)

	p10_27 = Plot([trace9_0, trace9_2, trace10_24, trace10_25, trace10_26, trace10_27, trace10_28, trace10_30], layout10_26)
	
end

# ╔═╡ 8892c48d-5647-4ecf-9edb-51370332d171
begin
	t = 500 # number of iterations we want to simulate
	n = length(d_1) # telling the routine how many initial conditions are in the loop
	d = [d_1  zeros(n, t-1)] # preallocation to increase performance

	 	for i = 1 : t-1 # the "for" loop
	     	d[i+1] = p + ((1+r)/(1+g))*d[i] 
	 	end
end

# ╔═╡ 095691a9-2b67-439e-a19f-61312496b3b5
begin
layout10_91 = Layout(;
		
		title_text = "The evolution of Public Debt as % of GDP", 
		title_x =0.5,
		
		hovermode="x",
		
		
        xaxis = attr(
               title = "Years", 
               #tickformat = "%Y",
               #hoverformat = "%Y-M%m",
               #tick0 = "1997/10/01",
               ),
		
        #xaxis_range = [2000, 2020],
        yaxis_title = "Debt / GDP",
        #yaxis_range=[-2, 2], 
        titlefont_size = 16)
Plot(d', mode = "lines", line_width = "2.5", layout10_91)
end

# ╔═╡ c7190cc0-08d8-45c8-b5de-e5630e0ff00e
html"""<style>
main {
    max-width: 900px;
    align-self: flex-start;
    margin-left: 100px;
}
"""

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
HypertextLiteral = "ac1192a8-f4b3-4bfe-ba22-af5b92cd3ab2"
LinearAlgebra = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"
NLsolve = "2774e3e8-f4cf-5e23-947b-6d7e65073b56"
PlotlyBase = "a03496cd-edff-5a9b-9e67-9cda94a718b5"
PlutoUI = "7f904dfe-b85e-4ff6-b463-dae2292396a8"

[compat]
HypertextLiteral = "~0.9.4"
NLsolve = "~4.5.1"
PlotlyBase = "~0.8.18"
PlutoUI = "~0.7.28"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.8.0"
manifest_format = "2.0"
project_hash = "558849beac2d0eef00ea04f6f2c63d8f56263294"

[[deps.AbstractPlutoDingetjes]]
deps = ["Pkg"]
git-tree-sha1 = "8eaf9f1b4921132a4cff3f36a1d9ba923b14a481"
uuid = "6e696c72-6542-2067-7265-42206c756150"
version = "1.1.4"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArrayInterfaceCore]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "d0f59ebfe8d3ea2799fb3fb88742d69978e5843e"
uuid = "30b0a656-2188-435a-8636-2ec0e6a096e2"
version = "0.1.10"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "9489214b993cd42d17f44c36e359bf6a7c919abf"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.0"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "1e315e3f4b0b7ce40feded39c73049692126cf53"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.3"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random"]
git-tree-sha1 = "7297381ccb5df764549818d9a7d57e45f1057d30"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.18.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "0f4e115f6f34bbe43c19751c90a38b2f380637b9"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.3"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "d08c20eef1f2cbc6e60fd3612ac4340b89fea322"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.9"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "417b0ed7b8b838aa6ca0a87aadf1bb9eb111ce40"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.8"

[[deps.CommonSubexpressions]]
deps = ["MacroTools", "Test"]
git-tree-sha1 = "7b8a93dba8af7e3b42fecabf646260105ac373f7"
uuid = "bbf7d656-a473-5ed7-a52c-81e309532950"
version = "0.3.0"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "924cdca592bc16f14d2f7006754a621735280b74"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.1.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "0.5.2+0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"

[[deps.DiffResults]]
deps = ["StaticArrays"]
git-tree-sha1 = "c18e98cba888c6c25d1c3b048e4b3380ca956805"
uuid = "163ba53b-c6d8-5494-b064-1a9d43ac40c5"
version = "1.0.3"

[[deps.DiffRules]]
deps = ["IrrationalConstants", "LogExpFunctions", "NaNMath", "Random", "SpecialFunctions"]
git-tree-sha1 = "28d605d9a0ac17118fe2c5e9ce0fbb76c3ceb120"
uuid = "b552c78f-8df3-52c6-915a-8e097449b14b"
version = "1.11.0"

[[deps.Distances]]
deps = ["LinearAlgebra", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "3258d0659f812acde79e8a74b11f17ac06d0ca04"
uuid = "b4f34e82-e78d-54a5-968a-f98e89d6e8f7"
version = "0.10.7"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "b19534d1895d702889b219c382a6e18010797f0b"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.8.6"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FiniteDiff]]
deps = ["ArrayInterfaceCore", "LinearAlgebra", "Requires", "SparseArrays", "StaticArrays"]
git-tree-sha1 = "a0700c21266b55bf62c22e75af5668aa7841b500"
uuid = "6a86dc24-6348-571c-b903-95158fe2bd41"
version = "2.12.1"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.ForwardDiff]]
deps = ["CommonSubexpressions", "DiffResults", "DiffRules", "LinearAlgebra", "LogExpFunctions", "NaNMath", "Preferences", "Printf", "Random", "SpecialFunctions", "StaticArrays"]
git-tree-sha1 = "2f18915445b248731ec5db4e4a17e451020bf21e"
uuid = "f6369f11-7733-5829-9624-2563aa707210"
version = "0.10.30"

[[deps.Hyperscript]]
deps = ["Test"]
git-tree-sha1 = "8d511d5b81240fc8e6802386302675bdf47737b9"
uuid = "47d2ed2b-36de-50cf-bf87-49c2cf4b8b91"
version = "0.0.4"

[[deps.HypertextLiteral]]
deps = ["Tricks"]
git-tree-sha1 = "c47c5fa4c5308f27ccaac35504858d8914e102f9"
uuid = "ac1192a8-f4b3-4bfe-ba22-af5b92cd3ab2"
version = "0.9.4"

[[deps.IOCapture]]
deps = ["Logging", "Random"]
git-tree-sha1 = "f7be53659ab06ddc986428d3a9dcc95f6fa6705a"
uuid = "b5f81e59-6552-4d32-b1f0-c071b021bf89"
version = "0.2.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "c6cf981474e7094ce044168d329274d797843467"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.6"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.LineSearches]]
deps = ["LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "Printf"]
git-tree-sha1 = "f27132e551e959b3667d8c93eae90973225032dd"
uuid = "d3d80556-e9d4-5f37-9878-2ab0fcc64255"
version = "7.1.1"

[[deps.LinearAlgebra]]
deps = ["Libdl", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "09e4b894ce6a976c354a69041a04748180d43637"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.15"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "3d3e902b31198a27340d0bf00d6ac452866021cf"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.9"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.2.1"

[[deps.NLSolversBase]]
deps = ["DiffResults", "Distributed", "FiniteDiff", "ForwardDiff"]
git-tree-sha1 = "50310f934e55e5ca3912fb941dec199b49ca9b68"
uuid = "d41bc354-129a-5804-8e4c-c37616107c6c"
version = "7.8.2"

[[deps.NLsolve]]
deps = ["Distances", "LineSearches", "LinearAlgebra", "NLSolversBase", "Printf", "Reexport"]
git-tree-sha1 = "019f12e9a1a7880459d0173c182e6a99365d7ac1"
uuid = "2774e3e8-f4cf-5e23-947b-6d7e65073b56"
version = "4.5.1"

[[deps.NaNMath]]
git-tree-sha1 = "b086b7ea07f8e38cf122f5016af580881ac914fe"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "0.3.7"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.20+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.Parameters]]
deps = ["OrderedCollections", "UnPack"]
git-tree-sha1 = "34c0e9ad262e5f7fc75b10a9952ca7692cfc5fbe"
uuid = "d96e819e-fc66-5662-9728-84c9c7592b0a"
version = "0.12.3"

[[deps.Parsers]]
deps = ["Dates"]
git-tree-sha1 = "1285416549ccfcdf0c50d4997a94331e88d68413"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.3.1"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.8.0"

[[deps.PlotlyBase]]
deps = ["ColorSchemes", "Dates", "DelimitedFiles", "DocStringExtensions", "JSON", "LaTeXStrings", "Logging", "Parameters", "Pkg", "REPL", "Requires", "Statistics", "UUIDs"]
git-tree-sha1 = "180d744848ba316a3d0fdf4dbd34b77c7242963a"
uuid = "a03496cd-edff-5a9b-9e67-9cda94a718b5"
version = "0.8.18"

[[deps.PlutoUI]]
deps = ["AbstractPlutoDingetjes", "Base64", "ColorTypes", "Dates", "Hyperscript", "HypertextLiteral", "IOCapture", "InteractiveUtils", "JSON", "Logging", "Markdown", "Random", "Reexport", "UUIDs"]
git-tree-sha1 = "8d1f54886b9037091edf146b517989fc4a09efec"
uuid = "7f904dfe-b85e-4ff6-b463-dae2292396a8"
version = "0.7.39"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SparseArrays]]
deps = ["LinearAlgebra", "Random"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "a9e798cae4867e3a41cae2dd9eb60c047f1212db"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.6"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "Statistics"]
git-tree-sha1 = "383a578bdf6e6721f480e749d503ebc8405a0b22"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.4.6"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "2c11d7290036fe7aac9038ff312d3b3a2a5bf89e"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.4.0"

[[deps.SuiteSparse]]
deps = ["Libdl", "LinearAlgebra", "Serialization", "SparseArrays"]
uuid = "4607b0f0-06f3-5cda-b6b1-a6196a1729e9"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.Tricks]]
git-tree-sha1 = "6bac775f2d42a611cdfcd1fb217ee719630c4175"
uuid = "410a4b4d-49e4-4fbc-ab6d-cb71b17b3775"
version = "0.1.6"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.UnPack]]
git-tree-sha1 = "387c1f73762231e86e0c9c5443ce3b4a0a9a0c2b"
uuid = "3a884ed6-31ef-47d7-9d2a-63182c4928ed"
version = "1.0.2"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.12+3"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl", "OpenBLAS_jll"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.1.1+0"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"
"""

# ╔═╡ Cell order:
# ╟─0b869e70-3717-11ec-202c-6b94dac7daf3
# ╠═b326715f-c37f-44d2-92f9-6264368a18b2
# ╟─694d78c7-4762-4d40-8f9a-6c3d16916d4e
# ╟─b72215bb-8e3a-46e2-8817-271befe1178c
# ╟─60bab761-8537-46e3-9940-953cd47da4be
# ╟─4109af60-6178-4148-8efe-890245077188
# ╟─25743265-a4d8-45c0-8c17-e75a2858441a
# ╟─12c9405e-d2c2-4894-b04a-a534b15fe669
# ╟─e56d9748-1b72-48cf-ab1e-da84807da7c4
# ╟─86f778d3-cda5-4933-ad27-d4ae04978c1e
# ╟─4b393146-306e-4c85-a5a3-8cdbb511331c
# ╟─8c9b8a47-b01e-49e7-8cc0-d6bd5ff9b723
# ╟─4e343e37-0beb-45ed-a879-adab6de87349
# ╟─0015b626-1347-45f5-aef7-2b9b6675038c
# ╟─9620f225-31b6-49f7-ba9c-efa940092463
# ╟─ecfc8987-e75b-4a8a-b4c6-71fcf45a8eff
# ╟─97c76502-6281-4870-9b39-42f485c1a447
# ╠═c7e2c3fc-bf1c-4b1b-882a-b9e36d66a32b
# ╟─9b0f3199-ff28-4820-bcad-e59bc65ce8a6
# ╟─541d8125-e5d0-46ec-a26d-aa1a130c38b2
# ╟─f6f3809e-76a7-4db4-8fb8-59c9ab5a4ffd
# ╟─b8871ae8-2abc-4d26-b8e6-e610d40d5a23
# ╟─f5494e4f-ca4a-4b5d-95b1-5acf21b82d78
# ╟─3da99da9-e09e-4ded-94a9-5b11f5c08313
# ╟─73e9803b-7d8b-4281-8e0c-8f2294ba7612
# ╟─3f211cef-c684-4e25-9144-19d68b0d8bd0
# ╟─cf06eb79-fc37-4784-b747-8a0965d5d436
# ╟─ff0f7991-1b37-44a1-a701-d8c071b6ac59
# ╟─4297e128-e56e-4624-a603-8f7343648b86
# ╟─308427f8-09ff-4370-8641-b3cd9a3668d1
# ╟─3a173221-bce2-4bd2-8078-1b4695df3bbe
# ╠═cff3fc5b-326b-4efe-836b-229cd23f83cc
# ╟─9b622087-ad34-4f19-9929-cbdf0256eae0
# ╟─7a8ac6a0-09cf-437e-9b8d-277182c0cdd0
# ╠═37e34e48-c2a7-4ffd-ac97-1a6ecb44ea92
# ╟─02d7d12a-9d2f-4ad4-8ad0-2fb15ea02cb7
# ╠═d3341903-3381-47bf-b6b0-6b909542a032
# ╠═700f5950-936d-46bd-9a9e-aa8ac4b9f653
# ╟─a8f0040c-5029-451d-99d8-4cc90c45fa40
# ╟─228f0209-c3ff-483a-bdd2-d7ef69e03b29
# ╟─5eb07074-11f2-4798-a080-bcde73e51b38
# ╟─f9b8b4a6-31f4-4168-acda-92796adf3102
# ╟─a5f978b7-4f8e-40b4-b52e-31e87d18c6a2
# ╟─ef51d01e-40c0-4b94-8308-4d3154c6099b
# ╟─8fb613a7-45b7-46dc-be33-4ac74609d920
# ╟─f3d1f71c-5108-4394-a98d-dc670f1091ae
# ╟─6db02201-bbe3-4ca8-a36b-7a5ac9e6385e
# ╟─f4efa92e-9a43-4bc3-8924-9ef7adeba5fd
# ╠═83da306c-64fa-4231-b396-b2006cd3ae05
# ╟─36a0155e-86a5-461a-9b29-bf5b12e29e1b
# ╟─4f2bd28d-abe2-43eb-9b7c-65e4ee574499
# ╟─4c42fa41-327b-4440-994b-61eb23f1fe0e
# ╟─46518335-709c-49e0-9f1c-8139f3b56ce8
# ╟─8253e219-eb1c-4d25-b52b-17483cdfc37a
# ╟─834f06dc-5e49-41e1-a226-a781c21fb50c
# ╟─d6a7f314-3c07-4634-80e7-863a223bbbf1
# ╟─b50b27f0-e713-42b8-98c1-d6594789e1e4
# ╟─762be1ac-c471-461f-b2c5-48d9f8c49b9d
# ╟─f0962852-02a2-4bf3-85b2-be0d4fb7bda4
# ╟─b721ee76-39ef-444b-aa90-5e199db90d42
# ╟─fc4af909-b4c5-4ebd-9e4b-fc93e3d31b8f
# ╠═1abf1b21-a268-45da-bcfc-b9cab7119ef4
# ╟─52c76dc2-146c-4178-9aa3-d132a0551168
# ╟─325f35d9-d2e7-49ac-a453-3c98fe0a0350
# ╟─3a9518c4-6d37-48bc-bab0-9c70c8db94f9
# ╟─efbdb70a-cecc-40c3-84a7-e21792731a2f
# ╟─fda12fd7-377c-47e1-9344-7b0300e58997
# ╟─a6bfca48-9beb-4e75-bd23-d71c448b10a0
# ╟─eb782414-b0e8-4a9a-b68d-cf75662f6ca6
# ╟─1bfeb360-0866-4a77-b7f4-34aff3541900
# ╟─4c790c8b-3192-4a75-acaa-c0224874a4d7
# ╟─5ec7390c-2383-4033-9089-1c051b806912
# ╟─095691a9-2b67-439e-a19f-61312496b3b5
# ╠═bc7a7a3d-b43a-4db1-9f42-212226e10a29
# ╟─f2956bed-9534-4c57-bfaa-fbef3c4af810
# ╟─edbd2b1c-1452-41a6-962c-3434bd420020
# ╠═d9672a6f-97af-43d1-9a30-50495204fec8
# ╠═0b4adabb-93f9-40d0-8571-b651dd68535c
# ╟─1bf47443-0ee4-482a-b637-8081620c144b
# ╟─8892c48d-5647-4ecf-9edb-51370332d171
# ╟─c7190cc0-08d8-45c8-b5de-e5630e0ff00e
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002
